;******************************************************************************
;    Filename:        uzemperc.asm                                            *
;******************************************************************************
;    percszmll  kamerhoz, multiplex kijelzssel                           *
;******************************************************************************
	list		p=16f1827	; list directive to define processor
	list		r=dec		; list directive to define radix
	#include	<p16f1827.inc>	; processor specific variables

; Konfigurci (2 sz)
    __CONFIG _CONFIG1, _FOSC_LP & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
    __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_OFF & _BORV_19 & _LVP_OFF

; Vltozk
	CBLOCK	0X70	
	SBUF:3		; kijelz (szegmenskd) puffer
    	M3REG		; multiplex szmll
	ITCNT		; megszaktsszmll (frekvenciaoszt)
    	AH		; Aritmetikai s konverzis
    	AL
    	BH
    	BL		; szubrutinok regiszterei
	S2REG		; gombnyoms msodpercszmll
	SECREG		; zemid msodpercszmll
	MINREG		; zemid percszmll
	FLAGS		; jelzbitek
	ENDC

#DEFINE	CAMON	FLAGS,3	; "kamera bekapcsolva" jelzbit
#DEFINE SECF	FLAGS,2	; msodperc bit
#DEFINE	NEWMIN	FLAGS,1	; percvlts trtnt (kijelzfrissts kell) 
#DEFINE	MINF	FLAGS,0	; perc flag (szmllhoz)
#DEFINE	TOGDP	ITCNT,5	; tizedespont villogtats srsge
#DEFINE DECP0	SBUF+2,2 ; hts tizedespont vezrlse
		
;------------------------------------------------------------------------------
; RESET VECTOR
;------------------------------------------------------------------------------
    ORG     0x0000            ; processor reset vector
    PAGESEL START
    GOTO    START             

;------------------------------------------------------------------------------
; INTERRUPT SERVICE ROUTINE
;------------------------------------------------------------------------------
    ORG      0x0004
;	BANKSEL	PORTA	; a fhurok csak ezt hasznlja, nem kell vlasztani
	BTFSS	PIR1,TMR2IF	; a TIMER2 megszakts elsbbsget lvez,
	GOTO	ALUDJ		; brmi ms elugrik		
	BCF	PIR1,TMR2IF	; kr bit trlse
	INCF	ITCNT,F		; megszaktsok szmllsa
	BTFSC	STATUS,Z
	BSF	SECF		; secf lltsa 256 t2 megszaktsonknt
	MOVF	M3REG,W		; soron kvetkez g relatv cme
	BRW			; ugrs (pc+1+W) cmre 
NULLAS	
	MOVLW	LOW (EGYES-NULLAS)	; hogy a kvetkez krben a kvetkez
	MOVWF	M3REG		; ugrcmet vlassza
	MOVLW	0XFF		; kiolt bjt rtke
	MOVWF	PORTB		; kiolts katdban a vlts idejre
	MOVLW	MASK0		; szmjegykijell sz tltse 1. jegyhez
	BTFSC	CAMON
	ANDLW	0XFD		; kamerallapot megrzse a kimen bjtban
	MOVWF	PORTA		; szmjegykijells 	
	MOVF	SBUF,W
	MOVWF	PORTB		; els szmjegy kdja a B portra
	RETFIE
EGYES
	MOVLW	LOW (KETTES-NULLAS)
	MOVWF	M3REG		; kvetkez ugrcm elksztse
	MOVLW	0XFF
	MOVWF	PORTB
	MOVLW	MASK1		; 2. jegyhez
	BTFSC	CAMON
	ANDLW	0XFD
	MOVWF	PORTA
	MOVF	SBUF+1,W	
	MOVWF	PORTB		; msodik
	RETFIE
KETTES
	MOVLW	LOW (NULLAS-NULLAS)
	MOVWF	M3REG
	MOVLW	0XFF
	MOVWF	PORTB
	MOVLW	MASK2
	BTFSC	CAMON
	ANDLW	0XFD
	MOVWF	PORTA
	MOVF	SBUF+2,W
	MOVWF	PORTB
	RETFIE

ALUDJ
	MOVLW	0XFF		; sszes szegmens kioltsa
	MOVWF	PORTB
	MOVWF	PORTA		; sszes digit kioltsa, kamera kikapcsolsa
	BCF	CAMON		; kamera jelzbit trlse
	BCF	PIR2,C1IF	; megszakts jelzbit trlse
; minreg s secreg mentse bels EEPROM-ba, szabvny szekvencival
	BANKSEL	EEADRL
	MOVLW	0
	MOVWF	EEADRL
	MOVF	MINREG,W
	MOVWF	EEDATL
	CALL	EWRI		; minreg a nulls cmre
	MOVLW	1
	MOVWF	EEADRL
	MOVF	SECREG,W	; secreg az 1-es cmre
	MOVWF	EEDATL
	CALL	EWRI
; lells elksztse	
	BANKSEL	TRISA
	CLRF	PIE1
	CLRF	PIE2
	BANKSEL	PORTA
	BCF	INTCON,GIE
	BCF	INTCON,PEIE
; terhels bekapcsolsa a maradk feszltsg gyors elfogyasztsa rdekben
	MOVLW	0XE3		; 3 digit on, kamera off
	MOVWF	PORTA
	CLRF	PORTB		; minden szegmens on
DURM
	SLEEP
	GOTO	DURM
	GOTO	DURM		; nem szabadul!

;------------------------------------------------------------------------------
; Fprogram
;------------------------------------------------------------------------------
; karaktergenertor a kapcsolsi rajz szerinti szegmenselrendezshez,
; a 0-9 tartomnyra (a 6 hexadecimlis karakter is belefrne)
CHARG
	DT	0X0C, 0X6F, 0X15, 0X07, 0X66, 0X86, 0X84, 0X2F
	DT	0X04, 0X06, 0XFF, 0XFF, 0XFF, 0XFF, 0XFF, 0XFF
; digitkijell bjtok (ahogy a hardverbl addik)
MASK2	EQU	0XFB	; (BIT2)
MASK1	EQU	0XF7	; (BIT3)
MASK0	EQU	0XEF	; (BIT4)
	 
START
	BANKSEL	ANSELA
	MOVLW	1		; RA.0 kompartor, tbb analg nincs
	MOVWF	ANSELA
	CLRF	ANSELB		; B port tiszta digitlis
	BANKSEL	PORTA
	MOVLW	0xFF		; A porton minden digit kioltva
	MOVWF	PORTA
	MOVLW	0XFF		; B porton minden szegmens kioltva
	MOVWF	PORTB
	CLRF	PIR1
	MOVLW	31		; timer2 peridus
	MOVWF	PR2
	MOVLW	0
	MOVWF	T2CON		; Csak bellts, mg nem indul	
	BANKSEL	TRISA
	MOVLW	0x08
	MOVWF	OPTION_REG
	BSF	PIE1,TMR2IE	; ez lesz az egyik engedlyezett megszakts
	MOVLW	0XE1		; a kzps 4 bit kimenet
	MOVWF	TRISA
	CLRF	TRISB		; a teljes B port kimenet
	BSF	PIE2,C1IE	; kompartor1 megszakts ( a msik)
	BANKSEL	WPUA
	MOVLW	0X20
	MOVWF	WPUA
	BANKSEL	LATA
	MOVLW	0X82
	MOVWF	CM1CON0
	MOVLW	0XA0
	MOVWF	CM1CON1
	MOVLW	0X88
	MOVWF	FVRCON
	NOP
	BANKSEL	PORTA
	CLRF	PIR1
	CLRF	PIR2
	CLRF	FLAGS
; minreg s secreg helyrelltsa bels eeprombl
	BANKSEL	EEADRL
	MOVLW	0
	MOVWF	EEADRL
	BCF	EECON1,CFGS
	BCF	EECON1,EEPGD
	BSF	EECON1,RD
	MOVF	EEDATL,W
	MOVWF	MINREG
	INCF	EEADRL,F
	BCF	EECON1,CFGS
	BCF	EECON1,EEPGD
	BSF	EECON1,RD
	MOVF	EEDATL,W
	MOVWF	SECREG
; rossz pillanatban jtt mentskor elfordulhat, hogy secreg=60 s
; a perc mg nem lpett. Ezt itt korrigljuk
	MOVLW	60
	SUBWF	SECREG,W
	BTFSS	STATUS,Z
	GOTO	SKCORR
	CLRF	SECREG
	INCF	MINREG,F
SKCORR
	CALL CVT			; korrekt szegmensregisztereket ad
	BANKSEL	PORTA
	MOVLW	LOW (NULLAS-NULLAS)	; a mux regiszter a nulls sorszm
	MOVWF	M3REG			; szmjegy programgt jellje ki
	BSF	INTCON,PEIE	; enlkl a kt pie hatstalan
	BSF	INTCON,GIE	; beengedem a tmr2 s a tp megszaktst
	BSF	T2CON,TMR2ON	; van megszakts, ra indul
MAIN				; ide jn vissza a teljes ciklus
	BTFSC	PORTA,5
	GOTO	MAIN		; indt (vagy reset) gombnyomsra vr
	CLRF	ITCNT
	CLRF	S2REG
	BCF	SECF
WC	
	BTFSS	SECF
	GOTO	SKINC2
	INCF	S2REG,F
	BCF	SECF
SKINC2
	BTFSC	S2REG,1		; 2x2=4 msodperc a 8 helyett
	BCF	SBUF+1,2	; KZPS DP
	BTFSS	PORTA,5
	GOTO	WC
	BCF	INTCON,GIE
	MOVF	S2REG,F
	BTFSS	STATUS,Z
	GOTO	JOGOMB
	MOVF	ITCNT,W
	ANDLW	0XF0
	BTFSS	STATUS,Z
	GOTO	JOGOMB
	BSF	INTCON,GIE
	GOTO	MAIN
JOGOMB	
	MOVF	S2REG,W
	ANDLW	0XFE
	BTFSS	STATUS,Z
	GOTO	CLRTIM
	CLRF	PIR1
	CLRF	PIR2
	BSF	CAMON
	CLRF	ITCNT
	BCF	SECF
	BCF	PORTA,1		; BEKAP
	BSF	INTCON,GIE
	BSF	NEWMIN
MEGY				; ITT KERING AMG FELVESZ
	BTFSS	SECF
	GOTO	SKINC
	INCF	SECREG,F
	BCF	SECF
	MOVLW	60		; (cjnel secreg,60,skinc)
	SUBWF	SECREG,W	;
	BTFSS	STATUS,Z	;
	GOTO	SKINC		;
	BSF	NEWMIN
	BCF	INTCON,GIE
	INCF	MINREG,F
	CLRF	SECREG
	BSF	INTCON,GIE
SKINC
	BTFSC	TOGDP		; Ha az ra jr, villog a hts tizedespont
	BCF	DECP0
	BTFSS	TOGDP
	BSF	DECP0
	BTFSS	NEWMIN
	GOTO	GTST2
	BCF	NEWMIN
	CALL	CVT
GTST2
	BTFSC	PORTA,5
	GOTO	MEGY
	BCF	CAMON
	BSF	DECP0
	BSF	PORTA,1
	CLRF	ITCNT
LP2	BTFSS	PORTA,5
	GOTO	LP2
	GOTO	MAIN		; fhurok vge

CLRTIM				; zemid trlse
	CLRF	ITCNT
	CLRF	MINREG
	CLRF	SECREG
	BSF	INTCON,GIE
	CALL	CVT
	GOTO	MAIN
			
CVT
	MOVF	MINREG,W
	MOVWF	BH
	CALL	HMDEC
	MOVF	AH,W
	ADDLW	LOW CHARG
	CALLW
	MOVWF	SBUF
	BCF	SBUF,2	; els tizedespont
	MOVF	AL,W
	ADDLW	LOW CHARG
	CALLW
	MOVWF	SBUF+1
	MOVF	BH,W
	ADDLW	LOW CHARG
	CALLW
	BTFSC	CAMON
	ANDLW	0XFB
	BTFSS	CAMON
	IORLW	0X4
	MOVWF	SBUF+2
	RETURN

; Binris PERC- bcd RA:PERC konverzi, eljel nlkli 1 bjtos egszrl, 
; Forrs BH, eredmny AH, AL, BH (a forrs elromlik).
; Olyan, mint egy szoksos binris-BCD konverzi, de az els jegy nem
; a szzasok, hanem a hatvanasok szma lesz, mert 60-nal osztunk.	
HMDEC				; tmr kd, hossz vgrehajts
	CLRF	AH
	CLRF	AL
HBCD
	MOVLW	60
	SUBWF	BH,W
	BTFSS	STATUS,C
	GOTO	N60
	MOVWF	BH
	INCF	AH,F
	GOTO	HBCD
N60
	MOVLW	10
	SUBWF	BH,W
	BTFSS	STATUS,C
	RETURN
	MOVWF	BH
	INCF	AL,F
	GOTO	N60
	
EWRI				; EEPROM r szubrutin 1 bjtra
	BCF	EECON1,CFGS
	BCF	EECON1,EEPGD
	BSF	EECON1,WREN
	BCF	INTCON,GIE
	MOVLW	55H
	MOVWF	EECON2
	MOVLW	0AAH
	MOVWF	EECON2
	BSF	EECON1,WR
	BCF	EECON1,WREN		
VIZSG
	BTFSS	EECON1,WR
	RETURN
	GOTO	VIZSG
	
; eeprom kezdrtk			
	ORG	0XF000
	DE	0, 0, 0, 0
	
	END	; VGE